<?php

/**
 * MyBB 1.6
 * calendar
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}
function calendar_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	
	global $lang;
	
	$lang->load("hyperportal",true);
	
	return array(
		"name"			=> $lang->h_info_calendar_title,
		"description"	=> $lang->h_info_calendar_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*",
		// Se puede poner si los usuarios anonimos pueden o no ver el bloque
		// Por default no pueden. Los admin pueden cambiar esto
		"guests"		=> 0
	);
	
	return return_array();
}
	
	function calendar()
	{
		
		global $cache,$templates,$lang,$mybb,$db,$widget_settings;

		require MYBB_ROOT.'/inc/functions_calendar.php';
		
		$lang->load("calendar");
		$month=my_date("m");
		$day=my_date("j");
		$year = my_date("Y");
		$offset=$widget_settings['calendar_amount'];
		$daylist="";
		
		//Get Events
		$init=gmmktime(0, 0, 0, $month, $day, $year);
		$end=gmmktime(23, 59, 59, $month, $day+$offset, $year);
		$events_cache = get_events($mybb->settings['wtwitter_mode'], $init, $end,true,$mybb->user['uid']);

		
		for($i=0;$i<$offset;$i++)
		{
			$date=mktime(0, 0, 0, $month, $day+$i, $year);

			$birthday_list="";
			$eventlist="";
			$birthdays = get_birthdays(date("n",$date),date("j",$date));
			$bdayhidden = 0;
			//$birthday_list.="$day-$month-$year".print_r($events_cache,true);
			//Before birthdays goes events	
			if(is_array($events_cache[date("j",$date)."-".date("n",$date)."-".date("Y",$date)]))
			{
				//$birthday_list.="A".print_r($events_cache["$day-$month-$year"],true);
				foreach($events_cache[date("j",$date)."-".date("n",$date)."-".date("Y",$date)] as $event)
				{
						$event['name'] = htmlspecialchars_uni($event['name']);
						$comma = $lang->comma;
						$eventlist.="<i>".$event['name']."</i>$comma";
				}
			}
			
			//Happy Birthdays!!
			if(is_array($birthdays))
			{
				$j=0;
				foreach($birthdays as $birthday)
				{
					$j++;
					if($birthday['birthdayprivacy'] == 'all')
					{
						

						$bday = explode("-", $birthday['birthday']);
						if($bday[2] && $bday[2] < $year)
						{
							$age = $year - $bday[2];
							$age = " (".$lang->sprintf($lang->years_old, $age).")";
						}
						else
						{
							$age = '';
						}
						$birthday['username'] = format_name($birthday['username'], $birthday['usergroup'], $birthday['displaygroup']);
						$birthday['profilelink'] = build_profile_link($birthday['username'], $birthday['uid']);
						
					
						$comma = $lang->comma;
						
						$birthday_list.=$birthday['profilelink']."$age".$comma;
					}
					else
					{
						++$bdayhidden;
					}
					
				}
			}
			if($birthday_list!="" || $eventlist!="")
			{
				$birthday_list=substr($birthday_list,0,strlen($birthday_list)-2);
				$eventlist=substr($eventlist,0,strlen($eventlist)-2);
				
				if($daylist!="")
				{
					$daylist.="<br/>";
				}
				$daylist.="<strong>".date("j/m",$date)."</strong> ";
				if($birthday_list!="" && $eventlist!="")
					$comma = $lang->comma;
				else 
					$comma="";
					
				$daylist.="$eventlist".$comma.$birthday_list;
			}

		}
		return $daylist;
	}

	function calendar_configuration()
{
	/**
	 * Set the configuration for the frontend portal
	 * title: The title of the configuration
	 * description: Description of what the configuration does
	 * optionscode: Type and data of the configuration
	 * value: Default value for the configuration
	
	 */
	
	global $lang;
	$lang->load("hyperportal");
		
	//TODO set to lang
	$settings = array(
		'calendar_amount' 		=> array(
				'title' 			=> $lang->h_calendar_settings_max_title, 
				'description' 		=> $lang->h_calendar_settings_max_description,
				'optionscode'		=> "select
1={$lang->h_calendar_settings_max_none}
5=5 {$lang->h_calendar_settings_max_days}
10=10 {$lang->h_calendar_settings_max_days}
20=20 {$lang->h_calendar_settings_max_days}
30=30 {$lang->h_calendar_settings_max_days}

",
				'value'				=> '5'),
	);
	return $settings;
	
	
}

function calendar_install()
	{
		global $db;
		//Create the admin settings
	$query = $db->query("SELECT disporder FROM ".TABLE_PREFIX."settinggroups ORDER BY `disporder` DESC LIMIT 1");
	$disporder = $db->fetch_field($query, 'disporder')+1;

	$setting_group = array(
	'name' 			=>	'wcalendar_settings',
	'title' 		=>	'Calendar Widget',
	'description' 	=>	'Settings to configure your HyperPortal Calendar Widget',
	'disporder' 	=>	intval($disporder),
	'isdefault' 	=>	'no'
	);
	$db->insert_query('settinggroups', $setting_group);
	$gid = $db->insert_id();

	$settings = array(
	'wcalendar_id' 		=> array(
	'title' 			=> 'Calendar Id',
	'description' 		=> 'Id of the calendar used for events',
	'optionscode'		=> 'text',
	'value'				=> '1')
	);

	$x = 1;
	foreach($settings as $name => $setting)
	{
		$insert_settings = array(
		'name' => $db->escape_string($prefix.$name),
		'title' => $db->escape_string($setting['title']),
		'description' => $db->escape_string($setting['description']),
		'optionscode' => $db->escape_string($setting['optionscode']),
		'value' => $db->escape_string($setting['value']),
		'disporder' => $x,
		'gid' => $gid,
		'isdefault' => 0
		);
		$db->insert_query('settings', $insert_settings);
		$x++;
	}

	rebuild_settings();

	
	}
	
	function calendar_uninstall()
	{
		global $db;
		
		// Remove settings
	$result = $db->simple_select('settinggroups', 'gid', "name = 'wcalendar_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);

	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}
	}
	

?>