<?php

/**
 * MyBB 1.6
 * PMs
 *
 * BrunoDiaz
 * UTNianos.com.ar 12/12/12
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}
function pms_info()
{
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	
	global $lang;
	
	$lang->load("hyperportal",true);
	
	return array(
		"name"			=> $lang->h_info_pms_title,
		"description"	=> $lang->h_info_pms_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "BrunoDiaz",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*",
		// Se puede poner si los usuarios anonimos pueden o no ver el bloque
		// Por default no pueden. Los admin pueden cambiar esto
		"guests"		=> 0
	);
	
	return return_array();
}
	
	function pms()
	{
		global $cache,$templates,$lang,$mybb,$db,$widget_settings;
		
		$lang->load("portal");	

			// Get Forum Statistics
	if($mybb->user['uid'] != 0 && $mybb->user['receivepms'] != 0 && $mybb->usergroup['canusepms'] != 0 && $mybb->settings['enablepms'] != 0)
	{
		switch($db->type)
		{
			case "sqlite":
			case "pgsql":
				$query = $db->simple_select("privatemessages", "COUNT(*) AS pms_total", "uid='".$mybb->user['uid']."'");
				$messages['pms_total'] = $db->fetch_field($query, "pms_total");
				
				$query = $db->simple_select("privatemessages", "COUNT(*) AS pms_unread", "uid='".$mybb->user['uid']."' AND CASE WHEN status = '0' AND folder = '0' THEN TRUE ELSE FALSE END");
				$messages['pms_unread'] = $db->fetch_field($query, "pms_unread");
				break;
			default:
				$query = $db->simple_select("privatemessages", "COUNT(*) AS pms_total, SUM(IF(status='0' AND folder='1','1','0')) AS pms_unread", "uid='".$mybb->user['uid']."'");
				$messages = $db->fetch_array($query);
		}
		
		// the SUM() thing returns "" instead of 0
		if($messages['pms_unread'] == "")
		{
			$messages['pms_unread'] = 0;
		}
		$lang->pms_received_new = $lang->sprintf($lang->pms_received_new, $mybb->user['username'], $messages['pms_unread']);
		
		//get unread messages list
		$query = $db->simple_select("privatemessages","subject,pmid,fromid","uid='".$mybb->user['uid']."' and status=0 and folder=1",array('order_by'=>'dateline desc','limit'=>$widget_settings['pms_amount']));
		

		$pmlist="";
		while($pm=$db->fetch_array($query))
		{
			$sender=get_user($pm['fromid']);
			$subject=substr($pm[subject],0,30);
			if(strlen($pm[subject])>30)
				$subject.="...";
			if($subject!="")
			$pmlist.="<br/><a href='private.php?action=read&pmid={$pm['pmid']}'>$subject</a> - ".build_profile_link($sender['username'],$pm['fromid']);
			
		}
		eval("\$pms = \"".$templates->get("widget_portal_pms")."\";");
		return $pms;
	}
	}

	function pms_configuration()
{
	/**
	 * Set the configuration for the frontend portal
	 * title: The title of the configuration
	 * description: Description of what the configuration does
	 * optionscode: Type and data of the configuration
	 * value: Default value for the configuration
	
	 */
	
	global $lang;
	$lang->load("hyperportal");
		
	//TODO set to lang
	$settings = array(
		'pms_amount' 		=> array(
				'title' 			=> $lang->h_pms_settings_max_title, 
				'description' 		=> $lang->h_pms_settings_max_description,
				'optionscode'		=> "select
0={$lang->h_pms_settings_max_none}
5=5
10=10
20=20
30=30
9999999={$lang->h_pms_settings_max_all}
",
				'value'				=> '5'),
	);
	return $settings;
	
	
}

function pms_install()
	{
		global $db;
		 //Now we create the default template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $template= array( 
    					"sid"		  => -1,
                        "title"       => "widget_portal_pms",
			     		"template"    => '<span class="smalltext">{$lang->pms_received_new}<br /><br />
<strong>&raquo; </strong> <strong>{$messages[pms_unread]}</strong> {$lang->pms_unread}<br />
<strong>&raquo; </strong> <strong>{$messages[pms_total]}</strong> {$lang->pms_total}</span>
{$pmlist}
<br /><br /><a href="{$mybb->settings[bburl]}/private.php">{$lang->welcome_pms}</a>
');
	 $db->insert_query("templates", $template);	
	}
	
	function pms_uninstall()
	{
		global $db;
	    //Now we delete the template
	    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	    $db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='widget_portal_pms'");
	}
	

?>