<?php

/**
 * MyBB 1.6
 * New posts widget
 *
 * RuloDiaz
 * UTNianos.com.ar 31/1/13e
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("No puede inicializarse de forma externa");
}

function hotThreads_info()
{

	global $lang;
	$lang->load("hyperportal",true);
	/**
	 * Array of information about the widget.
	 * name: The name of the plugin
	 * description: Description of what the plugin does
	 * website: The website the plugin is maintained at (Optional)
	 * author: The name of the author of the plugin
	 * authorsite: The URL to the website of the author (Optional)
	 * version: The version number of the plugin
	 * guid: Unique ID issued by the MyBB Mods site for version checking
	 * compatibility: A CSV list of MyBB versions supported. Ex, "121,123", "12*". Wildcards supported.
	 */
	return array(
		"name"			=> $lang->h_info_hotThreads_title,
		"description"	=> $lang->h_info_hotThreads_description,
		"website"		=> "http://www.utnianos.com.ar",
		"author"		=> "Rulo",
		"authorsite"	=> "http://www.utnianos.com.ar",
		"version"		=> "1.0",
		"guid" 			=> "",
		"compatibility" => "*"
	);
	
	return return_array();
	
	
}

function hotThreads_configuration()
{
	/**
	 * Set the configuration for the frontend portal
	 * title: The title of the configuration
	 * description: Description of what the configuration does
	 * optionscode: Type and data of the configuration
	 * value: Default value for the configuration
	
	 */
		
	//TODO set to lang
	$settings = array(
		'hotThreads_amount' 		=> array(
				'title' 			=> $lang->h_searchW_settings_max_title,
				'description' 		=> $lang->h_searchW_settings_max_description,
				'optionscode'		=> 'select
5=5
10=10
20=20
30=30
40=40
50=50
',
				'value'				=> '10'),
	);
	return $settings;
	
	
}

	function hotThreads_install()
	{
		global $db;
		 //Now we create the default template
    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
    $template= array( 
    					"sid"		  => -1,
                        "title"       => "widget_hotThreads_search_results_threads_thread",
			     		"template"    => '<tr>
	<td align="center" class="{$bgcolor} smalltext smalltext" width="2%"><img src="{$theme[imgdir]}/{$folder}.gif"  alt="{$folder_label}" title="{$folder_label}" /></td>
	<td align="center" class="{$bgcolor} smalltext" width="2%">{$icon}</td>
	<td class="{$bgcolor} smalltext">
		{$attachment_count}
		<div>
			<span>{$prefix} {$gotounread}{$thread[threadprefix]}<a href="{$thread_link}{$highlight}" class="{$inline_edit_class} {$new_class}" id="tid_{$inline_edit_tid}">{$thread[subject]}</a>{$thread[multipage]}</span>
			<div class="author smalltext">{$thread[profilelink]}</div>
		</div>
	</td>
	<td class="{$bgcolor} smalltext">{$thread[forumlink]}</td>
	<td class="{$bgcolor} smalltext" style="white-space: nowrap">
		<span class="smalltext">
			{$lastpostdate} {$lastposttime}<br />
			<a href="{$thread[lastpostlink]}">{$lang->lastpost}</a>: {$lastposterlink}
		</span>
	</td>
	{$inline_mod_checkbox}
</tr>');
	 $db->insert_query("templates", $template);	
	}
	
	function hotThreads_uninstall()
	{
		global $db;
	    //Now we delete the template
	    require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	    $db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='widget_hotThreads_search_results_threads_thread'");
	}
	
	function hotThreads()
	{
		global $theme,$plugins,$cache,$db,$mybb,$templates,$widget_settings,$lang;

		require_once MYBB_ROOT."inc/class_parser.php";
		$parser = new postParser;
		require_once MYBB_ROOT."inc/functions_search.php";
		
			
		$lang->load("search");
		$lang->load("hyperportal");
		
		$where_sql = "(t.replies >=".(string)$mybb->settings['hottopic']."|| t.views >=".(string)$mybb->settings['hottopicviews'].")";

		
		//TODO make fids configurable
		if($mybb->input['fid'])
		{
			$where_sql .= " AND t.fid='".intval($mybb->input['fid'])."'";
		}
		else if($mybb->input['fids'])
		{
			$fids = explode(',', $mybb->input['fids']);
			foreach($fids as $key => $fid)
			{
				$fids[$key] = intval($fid);
			}
			
			if(!empty($fids))
			{
				$where_sql .= " AND t.fid IN (".implode(',', $fids).")";
			}
		}
		
		$unsearchforums = get_unsearchable_forums();
		if($unsearchforums)
		{
			$where_sql .= " AND t.fid NOT IN ($unsearchforums)";
		}
		$inactiveforums = get_inactive_forums();
		if($inactiveforums)
		{
			$where_sql .= " AND t.fid NOT IN ($inactiveforums)";
		}
		
		$permsql = "";
		$onlyusfids = array();
	
		// Check group permissions if we can't view threads not started by us
		$group_permissions = forum_permissions();
		foreach($group_permissions as $fid => $forum_permissions)
		{
			if($forum_permissions['canonlyviewownthreads'] == 1)
			{
				$onlyusfids[] = $fid;
			}
		}
		if(!empty($onlyusfids))
		{
			$where_sql .= "AND ((t.fid IN(".implode(',', $onlyusfids).") AND t.uid='{$mybb->user['uid']}') OR t.fid NOT IN(".implode(',', $onlyusfids)."))";
		}
	
		$sid = md5(uniqid(microtime(), 1));
		$search = array(
			"sid" => $db->escape_string($sid),
			"uid" => $mybb->user['uid'],
			"dateline" => TIME_NOW,
			"ipaddress" => $db->escape_string($session->ipaddress),
			"threads" => '',
			"posts" => '',
			"resulttype" => "threads",
			"querycache" => $where_sql,
			"keywords" => ''
		);
		
		//Set the search configuration
		$sortfield = "t.lastpost";
		$sortby = "lastpost";
		$order = "desc";
		//I get one more so I can add the see more text
		$perpage=$limit=$widget_settings['hotThreads_amount']+1;
		$reallimit=$widget_settings['hotThreads_amount'];
		$start = 0;
		$page = 1;
		
		// Read some caches we will be using
		$forumcache = $cache->read("forums");
		$icon_cache = $cache->read("posticons");	
			
		$threads = array();
		$threadcount = 0;
		
		// Moderators can view unapproved threads
		$query = $db->simple_select("moderators", "fid", "(id='{$mybb->user['uid']}' AND isgroup='0') OR (id='{$mybb->user['usergroup']}' AND isgroup='1')");
		if($mybb->usergroup['issupermod'] == 1)
		{
			// Super moderators (and admins)
			$unapproved_where = "t.visible>-1";
		}
		elseif($db->num_rows($query))
		{
			// Normal moderators
			$moderated_forums = '0';
			while($forum = $db->fetch_array($query))
			{
				$moderated_forums .= ','.$forum['fid'];
			}
			$unapproved_where = "(t.visible>0 OR (t.visible=0 AND t.fid IN ({$moderated_forums})))";
		}
		else
		{
			// Normal users
			$unapproved_where = 't.visible>0';
		}
		
		// If we have saved WHERE conditions, execute them
		if($search['querycache'] != "")
		{
			$where_conditions = $search['querycache'];
			$query = $db->simple_select("threads t", "t.tid", $where_conditions. " AND {$unapproved_where} AND t.closed NOT LIKE 'moved|%' {$limitsql}");
			while($thread = $db->fetch_array($query))
			{
				$threads[$thread['tid']] = $thread['tid'];
				$threadcount++;
			}
			// Build our list of threads.
			if($threadcount > 0)
			{
				$search['threads'] = implode(",", $threads);
			}
			// No results.
			else
			{
				return $lang->error_nosearchresults;
			}
			$where_conditions = "t.tid IN (".$search['threads'].")";
		}
		
				// Begin selecting matching threads, cache them.
		$sqlarray = array(
			'order_by' => $sortfield,
			'order_dir' => $order,
			'limit_start' => $start,
			'limit' => $perpage
		);
		$query = $db->query("
			SELECT t.*, u.username AS userusername, p.displaystyle AS threadprefix
			FROM ".TABLE_PREFIX."threads t
			LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=t.uid)
			LEFT JOIN ".TABLE_PREFIX."threadprefixes p ON (p.pid=t.prefix)
			WHERE $where_conditions AND {$unapproved_where} {$permsql} AND t.closed NOT LIKE 'moved|%'
			ORDER BY $sortfield $order
			LIMIT $start, $perpage
		");
		$thread_cache = array();
		while($thread = $db->fetch_array($query))
		{
			$thread_cache[$thread['tid']] = $thread;
		}
		$thread_ids = implode(",", array_keys($thread_cache));
		
		if(empty($thread_ids))
		{
			return $lang->error_nosearchresults;
		}

		// Fetch dot icons if enabled
		if($mybb->settings['dotfolders'] != 0 && $mybb->user['uid'] && $thread_cache)
		{
			$query = $db->simple_select("posts", "DISTINCT tid,uid", "uid='".$mybb->user['uid']."' AND tid IN(".$thread_ids.")");
			while($thread = $db->fetch_array($query))
			{
				$thread_cache[$thread['tid']]['dot_icon'] = 1;
			}
		}

		// Fetch the read threads.
		if($mybb->user['uid'] && $mybb->settings['threadreadcut'] > 0)
		{
			$query = $db->simple_select("threadsread", "tid,dateline", "uid='".$mybb->user['uid']."' AND tid IN(".$thread_ids.")");
			while($readthread = $db->fetch_array($query))
			{
				$thread_cache[$readthread['tid']]['lastread'] = $readthread['dateline'];
			}
		}

		if(!$mybb->settings['maxmultipagelinks'])
		{
			$mybb->settings['maxmultipagelinks'] = 5;
		}
		
		$tcount=0;
		foreach($thread_cache as $thread)
		{

			$tcount++;
			if($tcount>$reallimit)
			{
				$getMore=true;
				break;
			}
			$bgcolor = alt_trow();
			$folder = '';
			$prefix = '';
			
			// Unapproved colour
			if(!$thread['visible'])
			{
				$bgcolor = 'trow_shaded';
			}

			if($thread['userusername'])
			{
				$thread['username'] = $thread['userusername'];
			}
			$thread['profilelink'] = build_profile_link($thread['username'], $thread['uid']);
			
			// If this thread has a prefix, insert a space between prefix and subject
			if($thread['prefix'] != 0)
			{
				$thread['threadprefix'] .= '&nbsp;';
			}
			
			$thread['subject'] = $parser->parse_badwords($thread['subject']);
			$thread['subject'] = htmlspecialchars_uni($thread['subject']);

			if($icon_cache[$thread['icon']])
			{
				$posticon = $icon_cache[$thread['icon']];
				$icon = "<img src=\"".$posticon['path']."\" alt=\"".$posticon['name']."\" />";
			}
			else
			{
				$icon = "&nbsp;";
			}
			if($thread['poll'])
			{
				$prefix = $lang->poll_prefix;
			}
				
			// Determine the folder
			$folder = '';
			$folder_label = '';
			if($thread['dot_icon'])
			{
				$folder = "dot_";
				$folder_label .= $lang->icon_dot;
			}
			$gotounread = '';
			$isnew = 0;
			$donenew = 0;
			$last_read = 0;
			
			if($mybb->settings['threadreadcut'] > 0 && $mybb->user['uid'])
			{
				$forum_read = $readforums[$thread['fid']];
			
				$read_cutoff = TIME_NOW-$mybb->settings['threadreadcut']*60*60*24;
				if($forum_read == 0 || $forum_read < $read_cutoff)
				{
					$forum_read = $read_cutoff;
				}
			}
			else
			{
				$forum_read = $forumsread[$thread['fid']];
			}
			
			if($mybb->settings['threadreadcut'] > 0 && $mybb->user['uid'] && $thread['lastpost'] > $forum_read)
			{
				if($thread['lastread'])
				{
					$last_read = $thread['lastread'];
				}
				else
				{
					$last_read = $read_cutoff;
				}
			}
			else
			{
				$last_read = my_get_array_cookie("threadread", $thread['tid']);
			}
	
			if($forum_read > $last_read)
			{
				$last_read = $forum_read;
			}

			if($thread['lastpost'] > $last_read && $last_read)
			{
				$folder .= "new";
				$new_class = "subject_new";
				$folder_label .= $lang->icon_new;
				$thread['newpostlink'] = get_thread_link($thread['tid'], 0, "newpost").$highlight;
				eval("\$gotounread = \"".$templates->get("forumdisplay_thread_gotounread")."\";");
				$unreadpost = 1;
			}
			else
			{
				$new_class = 'subject_old';
				$folder_label .= $lang->icon_no_new;
			}

			if($thread['replies'] >= $mybb->settings['hottopic'] || $thread['views'] >= $mybb->settings['hottopicviews'])
			{
				$folder .= "hot";
				$folder_label .= $lang->icon_hot;
			}
			if($thread['closed'] == 1)
			{
				$folder .= "lock";
				$folder_label .= $lang->icon_lock;
			}
			$folder .= "folder";
			
			if(!$mybb->settings['postsperpage'])
			{
				$mybb->settings['postperpage'] = 20;
			}

			$thread['pages'] = 0;
			$thread['multipage'] = '';
			$threadpages = '';
			$morelink = '';
			$thread['posts'] = $thread['replies'] + 1;
			if(is_moderator($thread['fid']))
			{
				$thread['posts'] += $thread['unapprovedposts'];
			}
			if($thread['posts'] > $mybb->settings['postsperpage'])
			{
				$thread['pages'] = $thread['posts'] / $mybb->settings['postsperpage'];
				$thread['pages'] = ceil($thread['pages']);
				if($thread['pages'] > $mybb->settings['maxmultipagelinks'])
				{
					$pagesstop = $mybb->settings['maxmultipagelinks'] - 1;
					$page_link = get_thread_link($thread['tid'], $thread['pages']).$highlight;
					eval("\$morelink = \"".$templates->get("forumdisplay_thread_multipage_more")."\";");
				}
				else
				{
					$pagesstop = $thread['pages'];
				}
				for($i = 1; $i <= $pagesstop; ++$i)
				{
					$page_link = get_thread_link($thread['tid'], $i).$highlight;
					eval("\$threadpages .= \"".$templates->get("forumdisplay_thread_multipage_page")."\";");
				}
				eval("\$thread['multipage'] = \"".$templates->get("forumdisplay_thread_multipage")."\";");
			}
			else
			{
				$threadpages = '';
				$morelink = '';
				$thread['multipage'] = '';
			}
			$lastpostdate = my_date($mybb->settings['dateformat'], $thread['lastpost']);
			$lastposttime = my_date($mybb->settings['timeformat'], $thread['lastpost']);
			$lastposter = $thread['lastposter'];
			$thread['lastpostlink'] = get_thread_link($thread['tid'], 0, "lastpost");
			$lastposteruid = $thread['lastposteruid'];
			$thread_link = get_thread_link($thread['tid']);

			// Don't link to guest's profiles (they have no profile).
			if($lastposteruid == 0)
			{
				$lastposterlink = $lastposter;
			}
			else
			{
				$lastposterlink = build_profile_link($lastposter, $lastposteruid);
			}

			$thread['replies'] = my_number_format($thread['replies']);
			$thread['views'] = my_number_format($thread['views']);

			if($forumcache[$thread['fid']])
			{
				$thread['forumlink'] = "<a href=\"".get_forum_link($thread['fid'])."\">".$forumcache[$thread['fid']]['name']."</a>";			}
			else
			{
				$thread['forumlink'] = "";
			}

			// If this user is the author of the thread and it is not closed or they are a moderator, they can edit
			if(($thread['uid'] == $mybb->user['uid'] && $thread['closed'] != 1 && $mybb->user['uid'] != 0 && $fpermissions[$thread['fid']]['caneditposts'] == 1) || is_moderator($thread['fid'], "caneditposts"))
			{
				$inline_edit_class = "subject_editable";
			}
			else
			{
				$inline_edit_class = "";
			}
			$load_inline_edit_js = 1;

			// If this thread has 1 or more attachments show the papperclip
			if($thread['attachmentcount'] > 0)
			{
				if($thread['attachmentcount'] > 1)
				{
					$attachment_count = $lang->sprintf($lang->attachment_count_multiple, $thread['attachmentcount']);
				}
				else
				{
					$attachment_count = $lang->attachment_count;
				}

				eval("\$attachment_count = \"".$templates->get("forumdisplay_thread_attachment_count")."\";");
			}
			else
			{
				$attachment_count = '';
			}

			$inline_edit_tid = $thread['tid'];
			
			// Inline thread moderation
			$inline_mod_checkbox = '';
			if($is_supermod || is_moderator($thread['fid']))
			{
				eval("\$inline_mod_checkbox = \"".$templates->get("search_results_threads_inlinecheck")."\";");
			}
			elseif($is_mod)
			{
				eval("\$inline_mod_checkbox = \"".$templates->get("search_results_threads_nocheck")."\";");
			}

			$plugins->run_hooks("search_results_thread");
			eval("\$results .= \"".$templates->get("widget_hotThreads_search_results_threads_thread")."\";");
		}
		if(!$results)
		{
			return $lang->error_nosearchresults;
		}
		else
		{
			if($load_inline_edit_js == 1)
			{
				eval("\$inline_edit_js = \"".$templates->get("forumdisplay_threadlist_inlineedit_js")."\";");
			}
		}
		//eval("\$searchresults = \"".$templates->get("search_results_threads")."\";");
		$searchresults="<table>$results</table>";
		if($getMore)
			$searchresults.="<a href='{$mybb->settings['bburl']}/search.php?action=hotThreads'>Ver todos</a>";
		//("\$tools = \"".$templates->get("widget_wa")."\";");
		//$tools=$widget_settings[bla].hyperportal_sectors.$widget_settings[ble];
		return $searchresults;
	}

?>